#!/usr/bin/env python

from douban_client import CoverGrabber
from file_op import FileOperation
from tag_handler import TagHandler
from result_parser import Parser,XmlParser

import sys,os
import getopt
import urllib,urllib2

grabber = CoverGrabber()
parser = XmlParser()
fo = FileOperation()

def usage():
    print "Usage: -h for help, -r for recursive scanning, -d for directory specification"

def file_handle(filename):
    print "Handling file:%s"%(filename)
    th = TagHandler(filename)
    if th.has_cover():
        print "Already has cover!"
    else:
        print "Grabbing cover for the song:%s album:%s"%(th.get_song_title(),th.get_album_title())
        xml_result = grabber.search_album_covers(th.get_album_title(),th.get_song_title(),filename,1)
        albums = parser.parse_result(xml_result)
        if len(albums) == 0:
            print "No matching album found!Next..."
        else:
            album = albums[0]
            image_url = album["image"]
            if image_url.find("http:") == 0:
                th.embed_cover(urllib.urlopen(image_url.replace("spic","lpic",1)).read())
                print "Cover embeded! Next..."
            else:
                print "No matching cover found! Next..."

def recur_handle(directory):
    fo.cd(directory)
    print "Entering:%s"%(directory)
    print "current:%s"%(os.getcwd())
    for filename in fo.ls_dir():
        if filename != "..":
            recur_handle(filename)
    for filename in fo.ls_file("*.mp3"):
        file_handle(filename)
    fo.cd("..")


if __name__ == '__main__':
    recursive = False
    directory = None
    try:
        opts,values = getopt.getopt(sys.argv[1:],"hrd:")
        for opt,arg in opts:
            print opt
            if opt == "-h":
                usage()
                sys.exit()
            elif opt == "-r":
                recursive = True
            elif opt == "-d":
                print arg
                directory = arg
    except getopt.GetoptError:
        usage()
        sys.exit(2)

    if not directory:
        print "Directory must be specified!"
        usage()
        sys.exit()

    fo.cd(directory)
    print "Scanning directory:%s"%(directory)
    if not recursive:
        for filename in os.listdir(directory):
            if filename.find(".mp3") > 0:
                file_handle(filename)
    else:
        recur_handle(directory)
