
import sys
import os
import glob

class FileOperation:
    currentdir = ""

    def __init__(self):
        try:
            from win32com.shell import shellcon,shell
            self.currentdir = shell.SHGetFolderPath(0, shellcon.CSIDL_APPDATA,0,0)
        except ImportError:
            self.currentdir = os.path.expanduser('~')
        self.cd(self.currentdir)

    def get_current_dir(self):
        return self.currentdir

    def cd(self,subdir):
        if os.path.isdir(self.currentdir):
            try:
                os.chdir(subdir)
                if subdir != '..':
                    self.currentdir = os.path.join(self.currentdir,subdir)
                else:
                    self.currentdir = os.path.dirname(self.currentdir)
                return True
            except WindowsError,OSError:
                return False
        else:
            return False

    def ls_dir(self):
        subdirs = []
        
        for subdir in os.listdir(self.currentdir):
            if os.path.isdir(os.path.join(self.currentdir,subdir)) and subdir.find('.') != 0:
                subdirs.append(subdir)
        subdirs.append("..")
        return subdirs

    def ls_file(self,wildcard):
        return glob.glob(os.path.join(self.currentdir,wildcard))

